//---------------------------------------------------------------------------

#include <vcl.h>
#include <iostream>
#include <iterator>
#include <list>
#include <algorithm>

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;


std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

template <class T>
inline void PRINT_ELEMENTS (const T& coll, const char* optcstr="")
{
  typename T::const_iterator pos;
  std::cout << ToRus(optcstr);
  for (pos=coll.begin(); pos!=coll.end(); ++pos) {
    std::cout <<*pos <<' ';
  }
  std::cout << std::endl;
}

class Nth {        //    true  n- 
  private:
    int nth;       //  ,     true
    int count;     //  
  public:
    Nth (int n) : nth(n), count(0) {
    }
    bool operator() (int) {
        return ++count == nth;
    }
};


int main(int argc, char* argv[])
{
  list<int> coll;

  //      1  9
  for (int i=1; i<=9; ++i) {
      coll.push_back(i);
  }
  PRINT_ELEMENTS(coll," :\n");

  //   
  list<int>::iterator pos;
  pos = remove_if(coll.begin(),coll.end(),  // 
                  Nth(3));                  //  
  coll.erase(pos,coll.end());

  PRINT_ELEMENTS(coll," :\n");

  getch();
  return 0;
}

//---------------------------------------------------------------------------